#include <stdlib.h>
#include <vga.h>
#include <vgagl.h>
#include "math.h"
#include "fractroam.h"

//see vga_setmode
#define GMODE G320x240x256


short* rgbbuf;

void init(void);
void print(void);

GraphicsContext *physicalscreen;
GraphicsContext *virtualscreen;

int main(void) {
  int keypressed=0;
  int ignore=0;
  fract_init();
  fract_plot();
  init();
  do {
    if (!ignore) {
      fract_update();
      fract_plot();
      print();
    }
    ignore=0;
    keypressed=vga_getkey();
    switch (keypressed) {
      case   0: break; // no key pressed
      case  32: // space (as a)
      case  97: fract_pilot_toggle(); break; //a -- toggle autopilot
      case 104: fract_move(0,-1,0); break; //h -- left
      case 106: fract_move(-1,0,0); break; //j -- down
      case 107: fract_move(1,0,0); break; //k -- up
      case 108: fract_move(0,1,0); break; //l -- right
      case 122: fract_move(0,0,-1); break; //z -- zoom in
      case 120: fract_move(0,0,1); break; //x -- zoom out
      case 115: fract_style_toggle(); break; // s -- style toggle
      case 116: fract_targets_toggle(); break; // t -- display targets toggle
      case  99: fract_color_cycle(); break; // c -- cycle color "palette"
      case 100: //d -- print out bounds
    	  printf("xmin: %f, xmax: %f, ymin: %f, ymax:%f\nx: %f, y: %f, width: %f (scale??)\n----\n",fract_bounds_get().xmin,fract_bounds_get().xmax,fract_bounds_get().ymin,fract_bounds_get().ymax,(fract_bounds_get().xmin+fract_bounds_get().xmax)/2, (fract_bounds_get().ymin+fract_bounds_get().ymax)/2,fract_bounds_get().xmax-fract_bounds_get().xmin);
      break;
      default: ignore = 1; break; // other key? who cares? :)
    }
  } while (keypressed != 113); // 113 = q

  vga_setmode(TEXT);
  return 0;
}

void init() {
  vga_init();
  vga_setmode(GMODE);
  gl_setcontextvga(GMODE);
  physicalscreen = gl_allocatecontext();
  gl_getcontext(physicalscreen);
  gl_setcontextvgavirtual(GMODE);
  virtualscreen = gl_allocatecontext();
  gl_getcontext(virtualscreen);
  gl_setcontext(virtualscreen);

  srandom(time(NULL));
}

void print(){
  int x,y,c;
  short* p=fract_get();
  for (y=0;y<DEFAULT_FRACT_HEIGHT;y++) {
    for (x=0;x<DEFAULT_FRACT_WIDTH;x++) {
      gl_setpixelrgb(x,y,*(p++),*(p++),*(p++));
    }
  }
  gl_copyscreen(physicalscreen);
}
